;IGT FREEPLAY
;------------
;
; written and designed by Dupuhini	
;	
; dupuhini@runbox.com
;
;
; COIN optic A	Negative pulse	u12 pin 2
; COIN optic B	Negative pulse	u12 pin 3
; COIN optic C	Negative pulse	u12 pin 4
;
; JP Reset		Negative pulse	u13 pin 2
;
;--------------------------------------------------------------------
;Port Assigments
;--------------------------------------------------------------------
;
; RA0 - OPTIC-A
; RA1 - OPTIC-B
; RA2 - OPTIC-C

; RB0	- CASH OUT BUTTON

;Program Initialise setup
;------------------------

	LIST  P=16F84A
 	#INCLUDE "p16f84a.inc"

;Configuration bits
;------------------

		__config 	_xt_osc & _wdt_off & _pwrte_on & _cp_off

;Variable ADDRESS Setup
;----------------------

TEMPA		EQU	H'0C'
CNTMSEC	EQU	H'0D'

;Defining some names for easy use and reference
;----------------------------------------------
;PORTA
;-----
#DEFINE	OPTICA		D'0'
#DEFINE	OPTICB 	D'1'
#DEFINE	OPTICC		D'2'
#DEFINE	COUTB		D'0'


;Main Program
;------------

		ORG 0
START		CLRF		PORTA				; MAKE ALL SIGNALS AFTER RESET 0 , ON PORT A
		CLRF 		PORTB				; MAKE ALL SIGNALS AFTER RESET 0 , ON PORT B

		BSF 		STATUS, RP0			; SELECT REGISTER BANK 1
        	MOVLW 		b'10000000'     		; USE PULL-UPS ON PORTB
		MOVWF		OPTION_REG                    
 		MOVLW 		b'00000001'     		; SELECT I/O DIRECTION FOR PORT B
        	MOVWF		PORTB                 
        	MOVLW 		b'00000'        		; SELECT I/O DIRECTION FOR PORT A
        	MOVWF 		PORTA                 
		BCF 		STATUS, RP0			; SELECT REGISTER BANK 0

		BCF		PORTA,OPTICA
		BCF		PORTA,OPTICB
   		BCF		PORTA,OPTICC

		CALL		DLY150
		CALL		DLY150
		CALL		DLY150
		CALL		DLY150

KEY		BTFSC		PORTB,COUTB
		GOTO		KEY				; LOOP
		CALL		DLY75				; 50
		BTFSC		PORTB,COUTB
		GOTO		KEY				; FALSE READ , GO BACK

		MOVLW		D'10'				; number of coins you want for each time
		MOVWF		TEMPA				; the cash out button is pressed

KEY2		BSF		PORTA,OPTICA
		CALL		DLY75
		BSF		PORTA,OPTICB
		CALL		DLY75
		BSF		PORTA,OPTICC
		CALL		DLY75
		BCF		PORTA,OPTICA
		CALL		DLY75
		BCF		PORTA,OPTICB
		CALL		DLY75
		BCF		PORTA,OPTICC
		CALL		DLY150
		CALL		DLY150
		DECFSZ		TEMPA
		GOTO		KEY2			
		GOTO		KEY	

;
;SUBROETINES
;-----------

DLY150		MOVLW		D'150'		; 150 ms
		GOTO		NMSEC

DLY75      MOVLW D'50'                 ; delay for 75 milliseconds
                ;*** N millisecond delay routine ***
NMSEC       MOVWF CNTMSEC              ; delay for N (in W) milliseconds
MSECLOOP    MOVLW D'248'               ; load takes 1 microsec
            CALL MICRO4                ; by itself CALL takes ...
                                       ; 2 + 247 X 4 + 3 + 2 = 995
            NOP                        ; 1 more microsec 
            DECFSZ CNTMSEC,f           ; 1 when skip not taken, else 2
            GOTO MSECLOOP              ; 2 here: total 1000 per msecloop
            RETURN                     ; final time through takes 999 to here
                                       ; overhead in and out ignored

                ;***  1 millisecond delay routine ***
ONEMSEC     MOVLW D'249'               ; 1 microsec for load W
                                       ; loops below take 248 X 4 + 3 = 995
MICRO4      ADDLW H'FF'                ; subtract 1 from 'W'
            BTFSS STATUS,Z             ; skip when you reach zero
            GOTO MICRO4                ; loops takes 4 microsec, 3 for last
            RETURN                     ; takes 2 microsec
                                       ; call + load  W + loops + return =
                                       ; 2 + 1 + 995 + 2 = 1000 microsec

END